unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  TAGraph, TAFuncSeries, TASeries, math;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1ConstantLine1: TConstantLine;
    Chart1ConstantLine2: TConstantLine;
    Chart1FuncSeries1: TFuncSeries;
    Label1: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    ScrollBar1: TScrollBar;
    procedure Chart1FuncSeries1Calculate(const AX: Double; out AY: Double);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  R0 = 100;
  A = 3.9083E-3;
  B = -5.775E-7;
  C = -4.183E-12;

function Calc_R(T, R0, A, B, C: Double): Double;
begin
  if T >= 0 then
    Result := R0 * (1 + A*T + B*T*T)
  else
    Result := R0 * (1 + A*T + B*T*T + C*(T-100)*T*T*T);
end;

// Ableitung dR/dT = Steigung der R(T) Kurve
function Calc_dRdT(T, R0, A, B, C: Double): Double;
begin
  if T >= 0 then
    Result := R0 * (A + 2*B*T)
  else
    Result := R0 * (A + 2*B*T - 300*C * T*T + 4*C*T*T*T);
end;

function Newton(R, R0, A, B, C: Double): Double;
const
  EPS = 1E-3;  // Geforderte Genauigkeit: 0.001 Grad dürften reichen
  MAX_IT = 10;
var
  dRdT: Double;  // Steigung der Tangente am Test-Punkt
  it: Integer;
  Rt: Double;
  T: Double;
begin
  it := 0;
  T := 0;  // anfängliche Schätzung T = 0°, dann ist R = R0
  repeat
    Rt := Calc_R(T, R0, A, B, C);
    dRdT := Calc_dRdT(T, R0, A, B, C);
    T := T - (Rt - R)/dRdT;  // neue Lösung nach diesem Iterationsschritt
    inc(it);
  until (abs(Rt - R) < EPS) or (it > MAX_IT);
  Result := T;
end;


{ TForm1 }

procedure TForm1.Chart1FuncSeries1Calculate(const AX: Double; out AY: Double);
begin
  AY := Calc_R(AX, R0, A, B, C);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  R1, R2: Double;
begin
  R1 := Calc_R(Chart1FuncSeries1.Extent.XMin, R0, A, B, C);
  R2 := Calc_R(Chart1FuncSeries1.Extent.Xmax, R0, A, B, C);
  Scrollbar1.Min := Round(R1);
  ScrollBar1.Max := Round(R2);
  ScrollBar1.Position := Round(R0);
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var
  R: Double;
  T: Double;
begin
  R := Scrollbar1.Position;
  Chart1ConstantLine1.Position := R;
  T := Newton(R, R0, A, b, C);
  Label1.Caption := 'R = ' + FloatToStr(R);
  Label2.Caption := 'T = ' + FloatToStr(T);
  Chart1ConstantLine2.Position := T;
end;


end.

